package skip;

import java.util.Iterator;
import java.util.NoSuchElementException;

public class SkipEachOtherIterator<A> implements Iterator<A> {
    // begin instance variables
    private final Iterator<A> around;
    private A nextElement;
    private boolean useNext;
    // end instance variables

    public SkipEachOtherIterator(final Iterator<A> around) {
        this.around = around;
        useNext = around.hasNext();
        if (useNext) {
            nextElement = around.next();
        }
    }

    public boolean hasNext() {
        return useNext;
    }

    private void prepNext() {
        useNext = false;
        if (around.hasNext()) {
            // skip the one
            around.next();
            if (around.hasNext()) {
                nextElement = around.next();
                useNext = true;
            }
        }
    }
    
    public A next() {
        if (!hasNext()) {
            throw new NoSuchElementException();
        }
        assert(useNext);
        final A retval = nextElement;
        prepNext();
        return retval;
    }
}

